﻿$sourceFile = $args[1]
$targetFile = $sourceFile -replace "\.\w+$", ".gpx"

function create-gpx
{
    "<?xml version='1.0'  encoding='utf-8' standalone='yes'?>"
    "<gpx creator='topgpx.ps1' version='1.1' xmlns='http://www.topografix.com/GPX/1/1'" 
    " xmlns:gpxx='http://www.garmin.com/xmlschemas/GpxExtensions/v3' xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'"
    " xsi:schemaLocation='http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd http://www.garmin.com/xmlschemas/GpxExtensions/v3 http://www.garmin.com/xmlschemas/GpxExtensions/v3/GpxExtensionsv3.xsd'>"
    foreach ($line in get-content $sourceFile)
    {
        if ($line -match "^((?<idx>\d+),)?(?<x>-?\d+\.\d+),(?<y>-?\d+\.\d+),(?<type>\d+),(?<speed>\d+),(?<dirtype>\d+),(?<dir>\d+)(,(?<dist>\d+),(?<angle>\d+))?(,"")?( // (?<cmt>.*))?$")
        {
            "<wpt lat='" + $matches.y + "' lon='" + $matches.x + "'>"
            switch ($matches.type)
            {
                1   { " <name>Камера " + $matches.speed + " км/ч@" + $matches.speed + "</name>" }
                2   { " <name>Камера на красный " + $matches.speed + " км/ч@" + $matches.speed + "</name>" }
                3   { " <name>Камера на красный " + $matches.speed + " км/ч</name>" }
                4   { " <name>Камера средней скорости " + $matches.speed + " км/ч@" + $matches.speed + "</name>" }
                5   { " <name>Мобильный пост ДПС@" + $matches.speed + "</name>" }
                6   { " <name>Мобильная камера " + $matches.speed + " км/ч@" + $matches.speed + "</name>" }
                7   { " <name>Мобильный пост (обгон, разметка)@" + $matches.speed + "</name>" }
                8   { " <name>Мобильный пост (STOP)</name>" }
                9   { " <name>Мобильный пост (пешеходный переход)</name>" }
                11  { " <name>Камера контроля полос " + $matches.speed + " км/ч</name>" }
                12  { " <name>Камера " + $matches.speed + " км/ч (в спину)@" + $matches.speed + "</name>" }
                20  { " <name>Стационарный пост ДПС@" + $matches.speed + "</name>" }
                21  { " <name>Железнодорожный переезд@" + $matches.speed + "</name>" }
                22  { " <name>Школьная зона@" + $matches.speed + "</name>" }
                100 { " <name>Начало населенного пункта@" + $matches.speed + "</name>" }
                101 { " <name>Ограничение скорости " + $matches.speed + " км/ч@" + $matches.speed + "</name>" }
                102 { " <name>Искусственная неровность@" + $matches.speed + "</name>" }
                103 { " <name>Плохая дорога@" + $matches.speed + "</name>" }
                104 { " <name>Опасный поворот@" + $matches.speed + "</name>" }
                105 { " <name>Опасный перекресток@" + $matches.speed + "</name>" }
                106 { " <name>Опасный участок@" + $matches.speed + "</name>" }
                107 { " <name>Запрет обгона@" + $matches.speed + "</name>" }
                201 { " <name>Затор слева</name>" }
                202 { " <name>Затор</name>" }
                203 { " <name>Затор справа</name>" }
            }
            " <desc>" + $matches.cmt + "</desc>"
            " <link href='" + $matches.type  + ".bmp' />"
            #" <link href='" + $matches.type  + ".wav' />"
            if ($matches.dist -gt 0)
            {
                " <extensions>"
                "  <gpxx:WaypointExtension>"
                "   <gpxx:Proximity>" + $matches.dist + "</gpxx:Proximity>"
                "  </gpxx:WaypointExtension>"
                " </extensions>"
            }
            "</wpt>"
        }
    }
    "</gpx>"
}
create-gpx | out-file $targetFile -Encoding UTF8
